import .imp_syntax
import .imp_common
import .imp_eval
import .imp_step
import .imp_semantics_facts

namespace imp

def abs_imp : stmt :=
  stmt.ifelse
    (expr.binary_op binary_op.lt (expr.var "i") (expr.val (val.int 0)))
    (stmt.set "i" (expr.unary_op unary_op.neg (expr.var "i")))
    stmt.nop.

lemma pos_abs_pos :
  forall (s: store) (i: int),
    store.lookup "i" s = some (val.int i) ->
    i > 0 ->
    step_star s abs_imp s stmt.nop :=
begin
  -- FIXME
  admit
end
      
def always_diverges (p : stmt) : Prop :=
  forall (s s' : store) (p' : stmt),
    step_star s p s' p' ->
    p' ≠ stmt.nop

def while_true_nop : stmt :=
  stmt.while (expr.val $ val.bool tt) stmt.nop.

lemma while_true_nop_diverges :
    always_diverges while_true_nop :=
begin
  -- FIXME
  admit
end